<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Prototype based object creation</title>
</head>

<body>
    <script>

        function CountryP(name, population, area) {
            this.name = name;
            this.population = population;
            this.area = area;
        }

        CountryP.prototype.getDetails = function () {
            return `
                Name: ${this.name}
                Population: ${this.population}
                Area: ${this.area}
            `;
        }

        let myGenericCountry = new CountryP('Utoopia', 123456, 9898);

        console.log(myGenericCountry);

        function RepublicP(name, population, area, president) {
            CountryP.call(this, name, population, area);
            this.president = president;
        }

        // RepublicP.prototype = Object.create(CountryP.prototype);
        Object.setPrototypeOf(RepublicP.prototype, CountryP.prototype);

        RepublicP.prototype.getDetails = function () {
            return CountryP.prototype.getDetails.call(this) + `
                President: ${this.president}
            `;
        }

        let estonia = new RepublicP('Eesti', 1300000, 45000, 'Kersti Kaljulaid');

        console.log(estonia);
    </script>
</body>

</html>